  /*
  static double Rot[3][3][3];
  static double fLenX[3];
  static double fLenY[3];
  static double ppX[3];
  static double ppY[3];
  static double zNear[3];
  static double zFar[3];
  */

    // Get Camera ID: Org 3 views: 1 time: close for end of 1st frames
    if ( vName[ vID9ref[iViewIdx] ] == UNDEFvID )
      vName[ vID9ref[iViewIdx] ]= p->view_id;
    Setup[iViewIdx]= TRUE;

    // Gen Camera ID: without org views: 1 time: close for end of 1st frames
    if (
      vName[ vID9ref[0] ] != UNDEFvID && // Center
      vName[ vID9ref[1] ] != UNDEFvID && // Left
      vName[ vID9ref[2] ] != UNDEFvID && // Right
      vName[1] == UNDEFvID
    ) {
      step_vName= ( vName[4] - vName[0] ) / 4;
      for ( unsigned int i= 0; i < GVDvS; i++ ) {
        if ( i != 0 && i != 4 && i != 8 ) {
          vName[i]= vName[0] + ( step_vName * i );
        }
      }
    }

    // Gen Trans/Near/Far: every frame: center view
    // Get fLen/pp/Rot: 1st time: center view
    if ( iViewIdx == 0 ) {
      Trans[0]= p->Trans[1];
      Trans[4]= p->Trans[0];
      Trans[8]= p->Trans[2];
      step_Trans= ( Trans[4] - Trans[0] ) / 4;
      for ( unsigned int i= 0; i < GVDvS; i++ ) {
        if ( i != 0 && i != 4 && i != 8 ) {
          Trans[i]= Trans[0] + ( step_Trans * i );
        }
      }

      for ( unsigned int i= 0; i < 3; i++ ) {
        // order 1/0/2 ?
        zNear[i]= p->zNear[i];
        zFar[i]= p->zFar[i];

        if ( FirstTime) {
          fLenX[i]= p->fLenX[i];
          fLenY[i]= p->fLenY[i];
          ppX[i]= p->ppX[i];
          ppY[i]= p->ppY[i];
          for ( unsigned int ii= 0; ii < 3; ii++ )
            for ( unsigned int iii= 0; iii < 3; iii++ )
              Rot[i][ii][iii]= p->Rot[i][ii][iii];
        }
      }
    }

    // Camera Parameter file out for Generic Dump.
    /*
    if ( p_Vid->GVD_Camera_Param_Dump != NULL && vName[1] != UNDEFvID ) {
      unsigned int i, x, y;
      if ( FirstTime ) {
        fprintf( p_Vid->GVD_Camera_Param_Dump, "# ViewNum, FrameID, " ); // FrameNo
        fprintf( p_Vid->GVD_Camera_Param_Dump, "ZNear,  ZFar,  " );
        fprintf( p_Vid->GVD_Camera_Param_Dump, "FocalLengthX, FocalLengthY, PrincipalPointX, PrincipalPointY, " );
        fprintf( p_Vid->GVD_Camera_Param_Dump, "Rot00,  Rot01,  Rot02,  Rot10,  Rot11,  Rot12,  Rot20,  Rot21,  Rot22,  " );
        fprintf( p_Vid->GVD_Camera_Param_Dump, "Translation" );
        fprintf( p_Vid->GVD_Camera_Param_Dump, "\n" );
      }

      for ( i= 0; i < p_Vid->numV; i++ ) {
        // fprintf( p_Vid->GVD_Camera_Param_Dump, "%6i,  ", p->fNO ); // for DEBUG
        fprintf( p_Vid->GVD_Camera_Param_Dump, "%6u,  ", frm_output_num );
        fprintf( p_Vid->GVD_Camera_Param_Dump, "%2u,  ", p->vID[i] );
        if ( p->z_flag ) {
          fprintf( p_Vid->GVD_Camera_Param_Dump, "%f,  ", p->zNear[i] );
          fprintf( p_Vid->GVD_Camera_Param_Dump, "%f,  ", p->zFar[i] );
        } else {
          fprintf( p_Vid->GVD_Camera_Param_Dump, ",  " );
          fprintf( p_Vid->GVD_Camera_Param_Dump, ",  " );
        }

        if ( p->intrinsic_param_flag ) {
          fprintf( p_Vid->GVD_Camera_Param_Dump, "%f,  ", p->fLenX[i] );
          fprintf( p_Vid->GVD_Camera_Param_Dump, "%f,  ", p->fLenY[i] );
          fprintf( p_Vid->GVD_Camera_Param_Dump, "%f,  ", p->ppX[i] );
          fprintf( p_Vid->GVD_Camera_Param_Dump, "%f,  ", p->ppY[i] );
        } else {
          fprintf( p_Vid->GVD_Camera_Param_Dump, ",  " );
          fprintf( p_Vid->GVD_Camera_Param_Dump, ",  " );
          fprintf( p_Vid->GVD_Camera_Param_Dump, ",  " );
          fprintf( p_Vid->GVD_Camera_Param_Dump, ",  " );
        }

        for ( x= 0; x < 3; x++) {
          for ( y= 0; y < 3; y++ ) {
            if ( p->rotation_flag ) {
              fprintf( p_Vid->GVD_Camera_Param_Dump, "%f,  ", p->Rot[i][x][y] );
            } else {
              fprintf( p_Vid->GVD_Camera_Param_Dump, ",  " );
            }
          }
        }

        if ( p->translation_flag ) {
          fprintf( p_Vid->GVD_Camera_Param_Dump, "%f  ", p->Trans[i] );
        }

        fprintf( p_Vid->GVD_Camera_Param_Dump, "\n" );
      }
    }
    */

    // Camera Parameter for GVD View Synth: 1 time: end of 1st frames
    if ( p_Vid->GVD_Camera_Param_File != NULL && vName[1] != UNDEFvID && FirstTime && isCompViews() ) {
      unsigned int ii;
      for ( unsigned int i= 0; i < GVDvS; i++ ) {
        switch ( i ) {
          case 0: case 1: case 2: ii= 1; break;
          case 4: case 3: case 5: ii= 0; break;
          case 8: case 6: case 7: ii= 2; break;
          default: ii= 0;
        }

        fprintf( p_Vid->GVD_Camera_Param_File, "View_%-2.2f\n", vName[i] );

        fprintf( p_Vid->GVD_Camera_Param_File, "%-6.6f%\t%-6.6f\t%-6.6f\n", fLenX[ii], 0.0, ppX[ii] );
        fprintf( p_Vid->GVD_Camera_Param_File, "%-6.6f%\t%-6.6f\t%-6.6f\n", 0.0, fLenY[ii], ppY[ii] );
        fprintf( p_Vid->GVD_Camera_Param_File, "%-6.6f%\t%-6.6f\t%-6.6f\n", 0.0, 0.0, 1.0 );
        fprintf( p_Vid->GVD_Camera_Param_File, "%1.1f\n", 0.0 );
        fprintf( p_Vid->GVD_Camera_Param_File, "%1.1f\n", 0.0 );
        fprintf( p_Vid->GVD_Camera_Param_File, "%-6.6f%\t%-6.6f\t%-6.6f\t%-6.6f\n", Rot[ii][0][0], Rot[ii][0][1], Rot[ii][0][2], Trans[i] );
        fprintf( p_Vid->GVD_Camera_Param_File, "%-6.6f%\t%-6.6f\t%-6.6f\t%-6.6f\n", Rot[ii][1][0], Rot[ii][1][1], Rot[ii][1][2], 0.0 );
        fprintf( p_Vid->GVD_Camera_Param_File, "%-6.6f%\t%-6.6f\t%-6.6f\t%-6.6f\n", Rot[ii][2][0], Rot[ii][2][1], Rot[ii][2][2], 0.0 );

        fprintf( p_Vid->GVD_Camera_Param_File, "\n" );
      }
    }
    if ( p_Vid->GVD_Camera_Param_File != NULL && vName[1] != UNDEFvID && FirstTime && Setup ) {
    }

    // Config file for GVD View Synth
    if ( p_Vid->GVD_Param_File != NULL && vName[1] != UNDEFvID && FirstTime ) {
      unsigned int i;
      char *vFName, *vExt;
      char *dFName, *dExt;

      fprintf( p_Vid->GVD_Param_File, "\n" );
      fprintf( p_Vid->GVD_Param_File, "Mode QUARTER_ODD_L\n" );
      fprintf( p_Vid->GVD_Param_File, "SourceWidth %u\n", p_Vid->width_ori );
      fprintf( p_Vid->GVD_Param_File, "SourceHeight %u\n", p_Vid->height_ori );
      fprintf( p_Vid->GVD_Param_File, "StartFrame 0\n" );
      fprintf( p_Vid->GVD_Param_File, "TotalNumberOfFrames -1\n" );
      fprintf( p_Vid->GVD_Param_File, "\n" );
      fprintf( p_Vid->GVD_Param_File, "CameraName1 View_%-2.2f\n", vName[0] );
      fprintf( p_Vid->GVD_Param_File, "CameraName2 View_%-2.2f\n", vName[4] );
      fprintf( p_Vid->GVD_Param_File, "CameraName3 View_%-2.2f\n", vName[8] );
      fprintf( p_Vid->GVD_Param_File, "\n" );
      for ( i= 0; i < GVDvS; i++ )
        fprintf( p_Vid->GVD_Param_File, "TargetCameraName%1u View_%-2.2f\n", i+1, vName[i] );
      fprintf( p_Vid->GVD_Param_File, "\n" );
      fprintf( p_Vid->GVD_Param_File, "# IN FILES\n" );
      fprintf( p_Vid->GVD_Param_File, "CameraParameterFile %s\n", p_Vid->p_Inp->GVDCameraParamFile );
      fprintf( p_Vid->GVD_Param_File, "NFTFile %s\n", p_Vid->p_Inp->GVDCameraParamNFT );
      vFName= strtok( p_Vid->p_Inp->outfile[0], "." );
      vExt= strtok( NULL, "." );
      dFName= strtok( p_Vid->p_Inp->outfile[1], "." );
      dExt= strtok( NULL, "." );
      fprintf( p_Vid->GVD_Param_File, "View2 %sV%-2.4f.%s\n", vFName, vName[4], vExt );
      fprintf( p_Vid->GVD_Param_File, "DepthBind %sV%-2.4f.%s\n", dFName, vName[4], dExt );
      fprintf( p_Vid->GVD_Param_File, "ResidualsBind %sV%-2.4f.%s\n", vFName, vName[0], vExt );
      fprintf( p_Vid->GVD_Param_File, "\n" );
      fprintf( p_Vid->GVD_Param_File, "# OUT FILES\n" );
      for ( i= 0; i < GVDvS; i++ )
        fprintf( p_Vid->GVD_Param_File, "Target%1u V3_%-2.4f.yuv\n", i+1, vName[i] );
    }

    // Camera Parameter(every frames) Near/Far/Trans for GVD View Synth
    if ( p_Vid->GVD_Camera_Param_NFT != NULL && vName[1] != UNDEFvID && isCompViews() ) {
      unsigned int i, ii;
      double NearL, NearR, FarL, FarR;

      NearL= ( zNear[0] >= zNear[1] ) ? zNear[1] : zNear[0];
      FarL= ( zFar[0] >= zFar[1] ) ? zFar[0] : zFar[1];
      NearR= ( zNear[2] >= zNear[1] ) ? zNear[1] : zNear[2];
      FarR= ( zFar[2] >= zFar[1] ) ? zFar[2] : zFar[1];

      fprintf(
        p_Vid->GVD_Camera_Param_NFT,
        "%-6.6f%\t%-6.6f\t%-6.6f\t"
        "%-6.6f%\t%-6.6f\t%-6.6f\t"
        "%-6.6f%\t%-6.6f\t%-6.6f\t"
        "%-6.6f%\t%-6.6f\t%-6.6f\t"
        "%-6.6f%\t%-6.6f\t%-6.6f\t"
        "%-6.6f%\t%-6.6f\t%-6.6f\t"
        "%-6.6f%\t%-6.6f\t%-6.6f\t"
        "%-6.6f%\t%-6.6f\t%-6.6f\t"
        "%-6.6f%\t%-6.6f\t%-6.6f\n",
        zNear[1], zFar[1], Trans[0],
        NearL, FarL, Trans[1],
        NearL, FarL, Trans[2],
        NearL, FarL, Trans[3],
        zNear[0], zFar[0], Trans[4],
        NearR, FarR, Trans[5],
        NearR, FarR, Trans[6],
        NearR, FarR, Trans[7],
        zNear[2], zFar[2], Trans[8]
      );
    }

    //printf("DEBUG: write_out_picture() ViewID: %d, IDX: %d, FirstTime: %d, isCompViews(): %d, Setup[0]: %d, Setup[1]: %d, Setup[2]: %d.\n", p->view_id, iViewIdx, FirstTime, isCompViews(), Setup[0], Setup[1], Setup[2] );
    //printf("DEBUG: write_out_picture() Trans[n]: %e, %e, %e, %e, %e, %e, %e, %e, %e.\n", Trans[0], Trans[1], Trans[2], Trans[3], Trans[4], Trans[5], Trans[6], Trans[7], Trans[8] );
    if ( vName[1] != UNDEFvID && FirstTime )
      FirstTime= FALSE;
    if ( isCompViews() )
      Setup[0]= Setup[1]= Setup[2]= FALSE;
