#pragma once

#define LEFT 1
#define RIGHT 2
#define CENTER 3

void VerticalCubicFilter_2D_half_V(BYTE **in, BYTE **out, int width, int height);
void VerticalCubicFilter_2D_half_D(BYTE **in, BYTE **out, int width, int height);
void VerticalCubicFilter_2D_quart_V(BYTE **in, BYTE **out, int width, int height, unsigned int side);
void VerticalCubicFilter_2D_quart_D(BYTE **in, BYTE **out, int width, int height, unsigned int side);

void VerticalCubicFilter_H(BYTE **in, BYTE **out, unsigned int width, unsigned int height);
void VerticalCubicFilter_Single(BYTE **in, BYTE **out, unsigned int width, unsigned int height);
void VerticalCubicFilter_Split(BYTE **in, BYTE **out, unsigned int width, unsigned int height, unsigned int side);
void HorizontalCubicFilter(BYTE **in, BYTE **out, unsigned int width, unsigned int height);
void VerticalCubicFilter_2DSingle(BYTE **in, BYTE **out, unsigned int width, unsigned int height);
void VerticalCubicFilter_2DStackSplit(BYTE **in, BYTE **out, unsigned int width, unsigned int height, unsigned int side);

void VerticalLowpassFilter3tap(BYTE **in, BYTE **out, int width, int height);
void HorizontalLowpassFilter3tap(BYTE **in, BYTE **out, int width, int height);
void VerticalLowpassFilter(BYTE **in, BYTE **out, int width, int height);
void HorizontalLowpassFilter(BYTE **in, BYTE **out, int width, int height, unsigned int th);

void VerticalLinearFilter_E_3tap(BYTE **in, BYTE **out, unsigned int width, unsigned int height, unsigned int th);
void VerticalLinearFilter_Single_3tap(BYTE **in, BYTE **out, unsigned int width, unsigned int height, unsigned int th);
void VerticalLinearFilter_Split_3tap(BYTE **in, BYTE **out, unsigned int width, unsigned int height, unsigned int side, unsigned int th);
void HorizontalLinearFilter_S_3tap(BYTE **in, BYTE **out, unsigned int width, unsigned int height, unsigned int th);

#define NARROW 7
#define STANDARD 15
#define WIDE 31

void DeblockF_7tap( BYTE **in, BYTE **out, unsigned int width, unsigned int height, unsigned int side, unsigned int th=10 );
void DeblockF( BYTE **in, BYTE **out, unsigned int width, unsigned int height, unsigned int side, unsigned int band=STANDARD, unsigned int th=10 );

void VerticalLinearFilter_E_2tap(BYTE **in, BYTE **out, unsigned int width, unsigned int height, unsigned int th);
void VerticalLinearFilter_Single_2tap(BYTE **in, BYTE **out, unsigned int width, unsigned int height, unsigned int th);
void VerticalLinearFilter_Split_2tap(BYTE **in, BYTE **out, unsigned int width, unsigned int height, unsigned int side, unsigned int th);
void HorizontalLinearFilter_S_2tap(BYTE **in, BYTE **out, unsigned int width, unsigned int height, unsigned int th);

void looseEdgeBindData( BYTE **data, BYTE **map, unsigned int width, unsigned int height );

void HorizontalLinearFilter_1D_half(BYTE *in, BYTE *out, int width, int padding_size);
void HorizontalLinearFilter_2D_half(BYTE **in, BYTE **out, int width, int height, int padding_size);
void HorizontalLinearFilter_1D_qpel(BYTE *in, BYTE *out, int width, int padding_size);
void HorizontalLinearFilter_2D_qpel(BYTE **in, BYTE **out, int width, int height, int padding_size);
void HorizontalAVCFilter_1D_half(BYTE *in, BYTE *out, int width, int padding_size);
void HorizontalAVCFilter_2D_half(BYTE **in, BYTE **out, int width, int height, int padding_size);
void HorizontalAVCFilter_1D_qpel(BYTE *in, BYTE *out, int width, int padding_size);
void HorizontalAVCFilter_2D_qpel(BYTE **in, BYTE **out, int width, int height, int padding_size);
void Horizontal6tapFilter_1D_half(BYTE *in, BYTE *out, int width, int padding_size, int coeff[6]);
void Horizontal6tapFilter_2D_half(BYTE **in, BYTE **out, int width, int height, int padding_size, int coeff[6]);
void HorizontalCubicFilter_1D_half(BYTE *in, BYTE *out, int width, int padding_size);
void HorizontalCubicFilter_2D_half(BYTE **in, BYTE **out, int width, int height, int padding_size);
void HorizontalCubicFilter_1D_qpel(BYTE *in, BYTE *out, int width, int padding_size);
void HorizontalCubicFilter_2D_qpel(BYTE **in, BYTE **out, int width, int height, int padding_size);
void DummyFilter_1D(BYTE *in, BYTE *out, int width, int padding_size);
void DummyFilter_2D(BYTE **in, BYTE **out, int width, int height, int padding_size);

#ifndef CLIP
#define CLIP(x,min,max) ( (x)<(min)?(min):((x)>(max)?(max):(x)) )
#endif

/*
 * TODO: More s/w work to encapsulate the above functions into the following class
 */

class CPictureResample
{
private:

  // Algorithm 0: Simple repeat /drop pixels
  void RepeatPixel420to444(unsigned char* oPic, unsigned char* iPic, int Width, int Height);
  void DropPixel444to420  (unsigned char* oPic, unsigned char* iPic, int Width, int Height);

  unsigned char PixelClip(const int pxlVal);
  
  void DoUpsample(unsigned char* Yo, unsigned char* Yi, int Width, int Height);
  void DoDownsample(unsigned char* Yo, unsigned char* Yi, int Width, int Height);

public:
  CPictureResample();
  ~CPictureResample();
  
  int  State();
  
  // For UV format conversion
  void PictureResample420to444(unsigned char* oPic, unsigned char* iPic, int Width, int Height);
  void PictureResample444to420(unsigned char* oPic, unsigned char* iPic, int Width, int Height);
  
  // For picture upsample and downsample
  int UpsampleView(unsigned char* Yo, unsigned char* Yi, int Width, int Height, int Factor);
  int DownsampleView(unsigned char* Yo, unsigned char* Yi, int Width, int Height, int Factor);
};

