#pragma once
// View Synthesis Decoder
// Last Update: Oct, 2012.

// Original code: View Synthesis Reference Software (VSRS) 3.5
//======================================created by Ying Chen =====================================
//===============Tampere University of Technology (TUT)/Nokia Research Center (NRC)===============

// # Any ID: LEFT to Right: 1, 2, 3

#include "iostream"
#include "string"

#include "ParameterBase.h"
#include "CameraParameter.h"

#define CAMERAS 13

class CParameterEncResiduals : public ParameterBase {
public:
  CParameterEncResiduals();
  virtual ~CParameterEncResiduals();

  Int Init( Int argc, Char** argv );

  void setMode( std::string s ) { m_Mode= s; }
  void setSourceWidth( unsigned int ui ) { m_uiSourceWidth= ui; }
  void setSourceHeight( unsigned int ui ) { m_uiSourceHeight= ui; }
  void setNumberOfFrames( unsigned int ui ) { m_uiNumberOfFrames= ui; }
  void setStartFrame( unsigned int ui ) { m_uiStartFrame= ui; }

  void setNearestDepthValue1( double d ) { m_dNearestDepthValue1= d; }
  void setFarthestDepthValue1( double d ) { m_dFarthestDepthValue1= d; }
  void setNearestDepthValue2( double d ) { m_dNearestDepthValue2= d; }
  void setFarthestDepthValue2( double d ) { m_dFarthestDepthValue2= d; }
  void setNearestDepthValue3( double d ) { m_dNearestDepthValue3= d; }
  void setFarthestDepthValue3( double d ) { m_dFarthestDepthValue3= d; }

  void setCameraParameterFileName( std::string s ) { m_CameraParameterFileName= s; };
  void setNFTFileName( std::string s ) { m_NFTFileName= s; };

  void set_VName( std::string s ) { m_VName= s; };
  void setBind_DName( std::string s ) { m_Bind_DName= s; };
  void setBind_RName( std::string s ) { m_Bind_RName= s; };
  void set_T1Name( std::string s ) { m_T1Name= s; };
  void set_T2Name( std::string s ) { m_T2Name= s; };
  void set_T3Name( std::string s ) { m_T3Name= s; };
  void set_T4Name( std::string s ) { m_T4Name= s; };
  void set_T6Name( std::string s ) { m_T6Name= s; };
  void set_T7Name( std::string s ) { m_T7Name= s; };
  void set_T8Name( std::string s ) { m_T8Name= s; };
  void set_T9Name( std::string s ) { m_T9Name= s; };

  const std::string getMode() { return m_Mode; }
  const unsigned int getSourceWidth() { return m_uiSourceWidth; }
  const unsigned int getSourceHeight() { return m_uiSourceHeight; }
  const unsigned int getNumberOfFrames() { return m_uiNumberOfFrames; }
  const unsigned int getStartFrame() { return m_uiStartFrame; }

  const double getNearestDepthValue1() { return m_dNearestDepthValue1; }
  const double getFarthestDepthValue1() { return m_dFarthestDepthValue1; }
  const double getNearestDepthValue2() { return m_dNearestDepthValue2; }
  const double getFarthestDepthValue2() { return m_dFarthestDepthValue2; }
  const double getNearestDepthValue3() { return m_dNearestDepthValue3; }
  const double getFarthestDepthValue3() { return m_dFarthestDepthValue3; }

  const std::string getCameraParameterFileName() { return m_CameraParameterFileName; }
  const std::string getNFTFileName() { return m_NFTFileName; }

  const std::string getCameraName1() { return m_CameraName1; }
  const std::string getCameraName2() { return m_CameraName2; }
  const std::string getCameraName3() { return m_CameraName3; }
  const std::string getVertualCameraName1() { return m_VertualCameraName1; }
  const std::string getVertualCameraName2() { return m_VertualCameraName2; }
  const std::string getTargetCameraName1() { return m_TargetCameraName1; }
  const std::string getTargetCameraName2() { return m_TargetCameraName2; }
  const std::string getTargetCameraName3() { return m_TargetCameraName3; }
  const std::string getTargetCameraName4() { return m_TargetCameraName4; }
  const std::string getTargetCameraName6() { return m_TargetCameraName6; }
  const std::string getTargetCameraName7() { return m_TargetCameraName7; }
  const std::string getTargetCameraName8() { return m_TargetCameraName8; }
  const std::string getTargetCameraName9() { return m_TargetCameraName9; }

  const std::string get_VName() { return m_VName; }
  const std::string getBind_DName() { return m_Bind_DName; }
  const std::string getBind_RName() { return m_Bind_RName; }
  const std::string get_T1Name() { return m_T1Name; }
  const std::string get_T2Name() { return m_T2Name; }
  const std::string get_T3Name() { return m_T3Name; }
  const std::string get_T4Name() { return m_T4Name; }
  const std::string get_T6Name() { return m_T6Name; }
  const std::string get_T7Name() { return m_T7Name; }
  const std::string get_T8Name() { return m_T8Name; }
  const std::string get_T9Name() { return m_T9Name; }

  void xPrintUsage();

  Double *getMat_Ex_1() {return &m_camParam[0].m_fExtrinsicMatrix[0][0];}
  Double *getMat_Ex_2() {return &m_camParam[1].m_fExtrinsicMatrix[0][0];}
  Double *getMat_Ex_3() {return &m_camParam[2].m_fExtrinsicMatrix[0][0];}
  Double *getMat_Ex_V1() {return &m_camParam[3].m_fExtrinsicMatrix[0][0];}
  Double *getMat_Ex_V2() {return &m_camParam[4].m_fExtrinsicMatrix[0][0];}
  Double *getMat_Ex_T1() {return &m_camParam[5].m_fExtrinsicMatrix[0][0];}
  Double *getMat_Ex_T2() {return &m_camParam[6].m_fExtrinsicMatrix[0][0];}
  Double *getMat_Ex_T3() {return &m_camParam[7].m_fExtrinsicMatrix[0][0];}
  Double *getMat_Ex_T4() {return &m_camParam[8].m_fExtrinsicMatrix[0][0];}
  Double *getMat_Ex_T6() {return &m_camParam[9].m_fExtrinsicMatrix[0][0];}
  Double *getMat_Ex_T7() {return &m_camParam[10].m_fExtrinsicMatrix[0][0];}
  Double *getMat_Ex_T8() {return &m_camParam[11].m_fExtrinsicMatrix[0][0];}
  Double *getMat_Ex_T9() {return &m_camParam[12].m_fExtrinsicMatrix[0][0];}

  Double *getMat_In_1() {return &m_camParam[0].m_fIntrinsicMatrix[0][0];}
  Double *getMat_In_2() {return &m_camParam[1].m_fIntrinsicMatrix[0][0];}
  Double *getMat_In_3() {return &m_camParam[2].m_fIntrinsicMatrix[0][0];}
  Double *getMat_In_V1() {return &m_camParam[3].m_fIntrinsicMatrix[0][0];}
  Double *getMat_In_V2() {return &m_camParam[4].m_fIntrinsicMatrix[0][0];}
  Double *getMat_In_T1() {return &m_camParam[5].m_fIntrinsicMatrix[0][0];}
  Double *getMat_In_T2() {return &m_camParam[6].m_fIntrinsicMatrix[0][0];}
  Double *getMat_In_T3() {return &m_camParam[7].m_fIntrinsicMatrix[0][0];}
  Double *getMat_In_T4() {return &m_camParam[8].m_fIntrinsicMatrix[0][0];}
  Double *getMat_In_T6() {return &m_camParam[9].m_fIntrinsicMatrix[0][0];}
  Double *getMat_In_T7() {return &m_camParam[10].m_fIntrinsicMatrix[0][0];}
  Double *getMat_In_T8() {return &m_camParam[11].m_fIntrinsicMatrix[0][0];}
  Double *getMat_In_T9() {return &m_camParam[12].m_fIntrinsicMatrix[0][0];}

  Double *getMat_Trans_1() {return &m_camParam[0].m_fTranslationVector[0];}
  Double *getMat_Trans_2() {return &m_camParam[1].m_fTranslationVector[0];}
  Double *getMat_Trans_3() {return &m_camParam[2].m_fTranslationVector[0];}
  Double *getMat_Trans_V1() {return &m_camParam[3].m_fTranslationVector[0];}
  Double *getMat_Trans_V2() {return &m_camParam[4].m_fTranslationVector[0];}
  Double *getMat_Trans_T1() {return &m_camParam[5].m_fTranslationVector[0];}
  Double *getMat_Trans_T2() {return &m_camParam[6].m_fTranslationVector[0];}
  Double *getMat_Trans_T3() {return &m_camParam[7].m_fTranslationVector[0];}
  Double *getMat_Trans_T4() {return &m_camParam[8].m_fTranslationVector[0];}
  Double *getMat_Trans_T6() {return &m_camParam[9].m_fTranslationVector[0];}
  Double *getMat_Trans_T7() {return &m_camParam[10].m_fTranslationVector[0];}
  Double *getMat_Trans_T8() {return &m_camParam[11].m_fTranslationVector[0];}
  Double *getMat_Trans_T9() {return &m_camParam[12].m_fTranslationVector[0];}


protected:
  unsigned int setup();


private:
  std::string m_Mode;
  unsigned int m_uiSourceWidth;
  unsigned int m_uiSourceHeight;
  unsigned int m_uiNumberOfFrames;
  unsigned int m_uiStartFrame;

  double m_dNearestDepthValue1;
  double m_dFarthestDepthValue1;
  double m_dNearestDepthValue2;
  double m_dFarthestDepthValue2;
  double m_dNearestDepthValue3;
  double m_dFarthestDepthValue3;

  std::string m_CameraName1;
  std::string m_CameraName2;
  std::string m_CameraName3;
  std::string m_VertualCameraName1;
  std::string m_VertualCameraName2;
  std::string m_TargetCameraName1;
  std::string m_TargetCameraName2;
  std::string m_TargetCameraName3;
  std::string m_TargetCameraName4;
  std::string m_TargetCameraName6;
  std::string m_TargetCameraName7;
  std::string m_TargetCameraName8;
  std::string m_TargetCameraName9;

  std::string m_CameraParameterFileName;
  std::string m_NFTFileName;

  std::string m_VName;
  std::string m_Bind_DName;
  std::string m_Bind_RName;
  std::string m_T1Name;
  std::string m_T2Name;
  std::string m_T3Name;
  std::string m_T4Name;
  std::string m_T6Name;
  std::string m_T7Name;
  std::string m_T8Name;
  std::string m_T9Name;

  // 0: Camera1, 1: Camera2, 2: Camera3, 3: VertualCamera1, 4:VertualCamera2
  // 5: TargetCameraName1, 6: TargetCameraName2
  CCameraParameters m_camParam[CAMERAS];

  bool xReadCameraParameters();
};
