#pragma once
// View Synthesis Decoder
// Last Update: Sep, 2013.

// for OpenCV 2.1.0 include <opencv/highgui.h>
#include <opencv2/opencv.hpp>
#include "ViewSynthesis.h"

class CSubSep {

public:
  CSubSep();
  virtual ~CSubSep();

  bool Init(
        unsigned int mode, unsigned int numView, bool variparam,
        unsigned int width, unsigned int height, unsigned int width_bind, unsigned int height_bind,
        double near1, double far1, double near2, double far2, double near3, double far3,  // 暫定処置
        const char *strRefCamID1, const char *strRefCamID2, const char *strRefCamID3,
        const char *strVirCamID1, const char *strVirCamID2,
        const char *strTarCamID1, const char *strTarCamID2, const char *strTarCamID3, const char *strTarCamID4,
        const char *strTarCamID6, const char *strTarCamID7, const char *strTarCamID8, const char *strTarCamID9,
        double Mat_In_1[9], double Mat_Ex_1[9], double Mat_Trans_1[3],
        double Mat_In_2[9], double Mat_Ex_2[9], double Mat_Trans_2[3],
        double Mat_In_3[9], double Mat_Ex_3[9], double Mat_Trans_3[3],
        double Mat_In_V1[9], double Mat_Ex_V1[9], double Mat_Trans_V1[3],
        double Mat_In_V2[9], double Mat_Ex_V2[9], double Mat_Trans_V2[3],
        double Mat_In_T1[9], double Mat_Ex_T1[9], double Mat_Trans_T1[3],
        double Mat_In_T2[9], double Mat_Ex_T2[9], double Mat_Trans_T2[3],
        double Mat_In_T3[9], double Mat_Ex_T3[9], double Mat_Trans_T3[3],
        double Mat_In_T4[9], double Mat_Ex_T4[9], double Mat_Trans_T4[3],
        double Mat_In_T6[9], double Mat_Ex_T6[9], double Mat_Trans_T6[3],
        double Mat_In_T7[9], double Mat_Ex_T7[9], double Mat_Trans_T7[3],
        double Mat_In_T8[9], double Mat_Ex_T8[9], double Mat_Trans_T8[3],
        double Mat_In_T9[9], double Mat_Ex_T9[9], double Mat_Trans_T9[3]
  );
  bool ReadOneFrame( FILE *fpV, FILE *fpR, FILE *fpD, unsigned int fnum, FILE *f_NFTfile );
  bool NoMix( FILE *fpT1, FILE *fpT2, FILE *fpT3, FILE *fpT4, FILE *fpT6, FILE *fpT7, FILE *fpT8, FILE *fpT9 );
  bool DoViewInterpolation();

  void setOptions(
        unsigned int pos,
        BYTE*** RefView, BYTE*** RefResiduals, BYTE** RefDepth, CIYuv *pSynYuvBuffer,
        double near_C1, double far_C1, double trans_C1,
        double near_C2, double far_C2, double trans_C2,
        double near_V1, double far_V1, double trans_V1,
        double near_T1, double far_T1, double trans_T1,
        unsigned int fnum, unsigned int from, bool debug=false
  );

private:
  CIYuv* pYuvRBind;
  CIYuv* pYuvR1;
  CIYuv* pYuvR2;
  CIYuv* pYuvDBind;
  CIYuv* pYuvDBindPRE;
  CIYuv* pYuvD1;
  CIYuv* pYuvD2;
  CIYuv* pYuvV;

  CIYuv* pYuvT[8];

  CIYuv* pYuvR1_temp;
  CIYuv* pYuvR2_temp;
  CIYuv* pYuvD1_temp;
  CIYuv* pYuvD2_temp;
  CIYuv* pYuvR1_half;
  CIYuv* pYuvR2_half;
  CIYuv* pYuvD1_half;
  CIYuv* pYuvD2_half;

  CIYuv* pYuvV_work;
  CIYuv* pYuvV_temp;

  CIYuv* pYuvRBind_work;
  CIYuv* pYuvDBind_work;
  CIYuv* pYuvRBind_work2;
  CIYuv* pYuvDBind_work2;

  IplImage*  m_img;

  unsigned int m_mode;
  unsigned int m_numView;
  unsigned int m_numDepth;
  bool m_globalDepth;
  bool m_fullSize;
  unsigned int m_width;
  unsigned int m_height;
  unsigned int m_width_bind;
  unsigned int m_height_bind;

  CViewInterpolation* m_pViewSyn[8];
};
