#pragma once
// View Synthesis Encoder for Depth, with GT-Fly
// Dev Enviroment:
//    Windows 7 64bit with Visual Studio 2010 C++ x64
//    OpenCV 2.4.2 64bit
// Last Update: Oct, 2012.

#include "DepthSynthesis.h"

namespace fn= view_synthesis::fnum_tri;

// Interface class between application and sysnthesis objects /////////////////////////
class CSubMix {

public:
  CSubMix();
  virtual ~CSubMix();

  bool Init(
        unsigned int mode, bool variparam,
        unsigned int width, unsigned int height, unsigned int width_bind, unsigned int height_bind,
        double near1, double far1, double near2, double far2, double near3, double far3,
        const char *strRefCamID1, const char *strRefCamID2, const char *strRefCamID3, 
        const char *strVirCamID1, const char *strVirCamID2,
        double Mat_In_1[9], double Mat_Ex_1[9], double Mat_Trans_1[3], 
        double Mat_In_2[9], double Mat_Ex_2[9], double Mat_Trans_2[3], 
        double Mat_In_3[9], double Mat_Ex_3[9], double Mat_Trans_3[3], 
        double Mat_In_V1[9], double Mat_Ex_V1[9], double Mat_Trans_V1[3],
        double Mat_In_V2[9], double Mat_Ex_V2[9], double Mat_Trans_V2[3]
  );
  
  bool ReadOneFrame(
        FILE *fp1, FILE *fp2, FILE *fp3, fn::tri fnum,
        // for VariParam
        FILE *f_D1near, FILE *f_D1far, FILE *f_D1trans,
        FILE *f_D2near, FILE *f_D2far, FILE *f_D2trans,
        FILE *f_D3near, FILE *f_D3far, FILE *f_D3trans,
        FILE *f_V1near, FILE *f_V1far, FILE *f_V1trans,
        FILE *f_V2near, FILE *f_V2far, FILE *f_V2trans
  );
  
  // bool DoSubMix(FILE *fp);
  bool DoSubMix(FILE *fp, FILE *fpD);
  bool DoDepthInterpolation();

private:
  CIYuv* pYuv1;
  CIYuv* pYuv2;
  CIYuv* pYuv3;
  CIYuv* pYuvBind;
  CIYuv* pYuvBindPre0;
  CIYuv* pYuvBindPre1;
  CIYuv* pYuvBindPre2;
  CIYuv* pYuvBindOut;
  CIYuv* pYuvOut;
  CIYuv* pYuvOutD;
  CIYuv* pYuvUnBind1;
  CIYuv* pYuvUnBind2;

  CIYuv* pYuv1_work;
  CIYuv* pYuv2_work;
  CIYuv* pYuv3_work;
  CIYuv* pYuv1_temp;
  CIYuv* pYuv2_temp;
  CIYuv* pYuv3_temp;
  
  view_synthesis::fnum_tri::tri m_fnum;
  
  IplImage*  m_img;
  IplImage*  m_imgD;
  
  unsigned int m_mode;
  unsigned int m_width;
  unsigned int m_height;
  unsigned int m_width_bind;
  unsigned int m_height_bind;
  bool m_vparam;
  
  CDepthInterpolationGeneral* m_pDepthSyn1;
  CDepthInterpolationGeneral* m_pDepthSyn2;
  
  // bool writeYUV( CIYuv *yuvSrc, FILE *fp, unsigned int height_bind );
  bool writeYUV( CIYuv *yuvSrc, FILE *fp, FILE *fpD, unsigned int height_bind );
  void smoothYUV( CIYuv *yuvSrc2, CIYuv *yuvSrc1, CIYuv *yuvSrc0, CIYuv *yuvDest, unsigned int height_bind );

};
